image: ruby:3.2-alpine

# Cache gems in between builds
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - vendor/ruby

test:
  script: ./scripts/verify_templates.rb

test-compare-reports-script:
  stage: test
  before_script:
    - ruby -v                                        # Print out ruby version for debugging
    - bundle install -j $(nproc) --path vendor/ruby  # Install dependencies into ./vendor/ruby
  script:
    - apk update && apk add jq py3-jsonschema
    - bundle exec rspec

shell check:
  image: koalaman/shellcheck-alpine:v0.7.1
  stage: test
  before_script:
    - shellcheck --version
  script:
    # SC2039: 'Something' is undefined https://github.com/koalaman/shellcheck/wiki/SC2039
    # SC2039 fails for local variables scoped to a function
    # BusyBox sh used by the Ruby alpine image has local support
    # Disabled because using local variables is more important than finding undefined variables
    - shellcheck -e SC2039 scripts/*.sh

shfmt:
  image: mvdan/shfmt:v3.1.0-alpine
  stage: test
  before_script:
    - shfmt -version
  script:
    - shfmt -i 2 -ci -d scripts
